# WP Data Access

* Contributors: [PeterSchulzNL](https://wpdataaccess.com/)
* Donate link: https://www.paypal.me/kpsch
* Requires at least: WordPress 4.8.3
* Tested up to: WordPress 6.0
* Stable tag: 5.2.1
* License: GPLv2 or later
* License URI: http://www.gnu.org/licenses/gpl-2.0.html

Create responsive, searchable, sortable, exportable tables from SQL Server, ProgreSQL, Oracle, MS Access, MySQL, MariaDB, CSV, JSON and XML sources

== Description ==
WP Data Access is a powerful data administration, publication, and development tool. This highly customizable plugin allows users to perform database-related tasks from the WordPress dashboard through an intuitive user interface, enabling the creation of fully responsive publications, charts, and data administration pages. No programming skills required!

The plugin supports more complex features for advanced users, including remote database and file access, master-detail pages, lookups, inline editing, advanced search options, and WordPress role management integration. Additionally, it acts as an additional layer around your WordPress database, allowing you to add database tables and view specific functionality such as dynamic hyperlinks and WordPress media library integration.

Programmers can also benefit from the WP Data Access API, which can be used to access remote databases and data files directly from their PHP code.

### Data Publisher
> The Data Publisher can be used to publish a database table via your WordPress back-end or front-end. This tool can make a publication fully responsive. Key elements of Data Publisher include the ability to easily add export buttons, search panes, the search builder, and to employ professional page styling using the intuitive premium user interface. Advanced and premium features are available for users who want to get the most out of their publications and harness the true power of this tool.

* Easy level: no coding skills required
* Advanced level: JSON configuration
* Expert level: add custom JavaScript functions


* Global searching and sorting
* Custom CSS styling [[demo]](https://wpdataaccess.com/demos/demos-data-publisher/data-publisher-free-styling/)
* Server-side processing
* Client-side processing [[demo]](https://wpdataaccess.com/row-grouping-client-side/)
* Export to CSV, Excel, PDF and SQL, Print and Copy buttons (PREMIUM) [[demo]](https://wpdataaccess.com/search-panes-demo-without-buttons/)
* Integrated geolocation search (PREMIUM) [[demo]](https://wpdataaccess.com/publication-using-geolocation/)
* Multiple advanced search options (PREMIUM)
* Interactive Search Builder (PREMIUM) [[demo]](https://wpdataaccess.com/search-builder-demo/)
* Interactive Search Panes (PREMIUM) [[demo]](https://wpdataaccess.com/search-panes-demo-without-buttons/)
* Custom queries and custom post types (PREMIUM)

### Remote database and file access
> WP Data Access supports seamless access to several remote databases (SQL Server, Oracle, ProgreSQL, MariaDB/MySQL, and MS Access) and remote data files (CSV, JSON, and XML). To facilitate this access, the remote connection wizard helps premium users set up the connection. However, documentation is available for free users (requires DBMS and OS knowledge and root access).

Database tables created from remote database connections and remote data files are available from all plugin tools. Publications, charts, and projects can utilize these database tables.

#### Remote SQL Server example
Make sure your SQL Server is accessible. Premium users can use the remote connection wizard to create a database table using a remote connection to your SQL Server.
#### Remote CSV files example
Make your CSV file available from a public URL. Use the remote connection wizard to load your CSV file into a database table and add an update interval. Maintain your CSV file with your favorite spreadsheet program while WP Data Access synchronizes your table at your desired update intervals.

### Charts
> Charts are created from SQL queries. Use the Query Builder to manage your queries and copy them into your charts. The Visual Query Builder is a premium feature that can be used by those with little or no SQL knowledge.

* Google Charts integration
* Bar, column, line and pie charts, histograms, gauges and data tables are supported [[demo]](https://wpdataaccess.com/2022/06/16/chart-demo/)

### Geolocation maps
> Create a searchable geolocation map from a database table containing geolocation information.

* Google Maps integration (PREMIUM)
* Define map settings per table (PREMIUM)
* Dynamic marker layout configuration (PREMIUM)
* Use static or user location (PREMIUM)
* Search map within adjustable radius (PREMIUM) [[demo]](https://wpdataaccess.com/demos/geolocation-demo/)

### Dashboards and widgets
> Dashboards are designed for back-end usage. Widgets are highly customizable and can be shown on dashboards (back-end), webpages (front-end), and external websites.

* Manage all your data in one location
* Share your data widgets anywhere (PREMIUM)
* Give specific users and user groups access to locked dashboards (PREMIUM)
* Allow users to create their own dashboards (PREMIUM)

### Query Builder
> Execute SQL queries directly from your WordPress dashboard.

* Work on multiple SQL queries simultaneously (using tabs)
* Save and reuse queries (for publications and charts)
* Protects WordPress table structures and data
* Interactive Visual Query Builder for user with limited SQL knowledge (PREMIUM)

### Data Projects and Project Templates
> Use Data Projects and Project Templates to write WordPress data apps. Apps can be executed on the back-end or the front-end using shortcodes.

* Auto generated CRUD pages
* Parent-child relationships
* Lookups
* Remote and local databases
* WordPress role integration
* WordPress media library integration
* Accessible from the WordPress dashboard and public pages
* DataForms - fully responsive apps for back-end and front-end (PREMIUM) [[demo]](https://wpdataaccess.com/demos/data-forms-project-demo/)
* Inline editing (PREMIUM)
* Full-text search (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Data Explorer
> The Data Explorer helps you to manage local and remote data and databases from a single location.

* Manage local and remote databases
* Import SQL and CSV files (supports ZIP for large import files)
* Exports to SQL, CSV, JSON and XML (supports extremely large table exports)
* Rename, copy, truncate, drop, optimize and alter tables
* Change table and column settings (advanced search, geolocation, inline editing and more)
* Enable WordPress Media Library integration for specific table columns
* Enable inline editing for specific table columns (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Data Designer
> Create and alter tables and indexes using an intuitive user interface.

* Create and alter tables and indexes
* Supports reverse engineering and reconciliation

### Plugin Settings
> WP Data Access is highly customizable. Many detailed plugin settings are available to manage the plugin user interface and behavior.

### Useful Links

[» Plugin Website](https://wpdataaccess.com/)
[» Documentation](https://wpdataaccess.com/docs/documentation/)
[» Demos](https://wpdataaccess.com/demos/)

## License

WP Data Access is licensed under the [GPL v2](http://www.gnu.org/licenses/gpl-2.0.html) or later.

> This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

> This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

> You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
